<?
include("config.php");
include("$hq_base/conf/master.cf");
include("$hq_base/conf/bar_graph.cf");
include("$hq_base/lib/util.phl");
include("$hq_base/lib/logparser.phl");
include("$hq_base/lib/db.phl");
include("$hq_base/lib/super.phl");
include("$hq_base/lib/app.phl");
include("$hq_base/lib/graph.phl");
include("$hq_base/lib/graph_stat.phl");

function get_bar_value($db,$min,$max,$qs)
{
$q = new SQLquery($db);
$q->RQuery("select count(*) from request where " .
           "(utime >= $min) and (utime < $max) " . $qs);
if (! $q->Rcount())
  { return 0; }
$a=$q->FetchRow();
$q->Free();
return $a[0];
}

$t_min = $sdate;
$t_max = $edate;

set_time_limit(3000);

$db = new DBlink($db_host,$db_port,$db_name,$db_user,$db_pass);
if (! $db->DBopen() )
  {
    dieimg("failed to open DBMS");
  }
if (! $qa=mk_query($db,0,0,$ip,$dname,$portno))
  {
    dieimg("mkquery: inkorrect parameters");
  }

$q = new SQLquery($db);
$q->RQuery("select min(utime),max(utime) from request where " .
           "(udate > $sdate) and (udate < $edate)");
$r = $q->FetchRow();
$umin=60 * intval($r[0] / 60);
$umax=60 * intval($r[1] / 60);;

$ticv = intval($bar_width * ($umax - $umin) / ($pic_width-40));


$sbar = new BarGraph($pic_width,$pic_height);
$sbar->setBARwidth($bar_width);
$sbar->SetGraphVP(70,40,$pic_width-90,$pic_height-60,$umin,$umax);
$sbar->setYminExplicit(0.0);
$sbar->setBGcol($bg_r,$bg_g,$bg_b);
$sbar->setBarcol($ol_bar_r,$ol_bar_g,$ol_bar_b);
$sbar->setBarFillcol($fill_bar_r,$fill_bar_g,$fill_bar_b);
$sbar->setAXIScol($ax_r,$ax_g,$ax_b);
$sbar->setGRID1col($grid_r,$grid_g,$grid_b);

$q = new SQLquery($db);
if (! $sbar->getTimeTic() )
  {
    dieimg("no data found");
  }
$umin = $sbar->getTimeTic() * intval($umin / $sbar->getTimeTic() + 0.5);
$umax = $sbar->getTimeTic() * intval($umax / $sbar->getTimeTic() + 0.5);

$n=0;
for ($u = $umin, $ut=$umin+$sbar->getTimeTic();
     $ut < $umax;
     $ut += $sbar->getTimeTic())
   {
     $v=get_bar_value($db,$u,$ut,$qa);
     $sbar->AddDist($u,$v);
     $u = $ut;
     $n++;
   }

$db->DBclose();
if (! $n)
  {
    $sbar->dbgpr("no data found");
    imagepng($sbar->image);
  }
else
  {
    $sbar->Draw();
  }
exit(0);
?>
